//+------------------------------------------------------------------+
//|                                            LinearRegSlope_v1.mq4 |
//|                                Copyright  2006, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 SkyBlue
#property indicator_width1 2

//---- input parameters
extern int     Price          =  0;  //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 

//---- indicator buffers
double RegSlope[],Z;
double RegSlopea[],RegSlopeb[],RegSlopec[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   
   SetIndexBuffer(0,RegSlope);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,RegSlopea);
   SetIndexBuffer(2,RegSlopeb);
   SetIndexBuffer(3,RegSlopec);
      

   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label

 
  return(0);
  }

//+------------------------------------------------------------------+
//| LinearRegSlope_v1                                                      |
//+------------------------------------------------------------------+
int start()
{
   int    i,shift, counted_bars=IndicatorCounted(),limit;
   
   double price;      
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-5-1; 
   if ( counted_bars < 1 ) 
   
   for(i=1;i<5;i++) RegSlopea[Bars-i]=0;    
   double SumBarsa = 5 * (5 - 1) * 0.5;
   double SumSqrBarsa = (5 - 1.0) * 5 * (2.0 * 5 - 1.0) / 6.0;
   for(shift=limit;shift>=0;shift--) 
   {	
   double Sum1a = 0;
   for(i=0;i<=5-1;i++) Sum1a += i*iMA(NULL,0,1,0,1,Price,i+shift);
   double SumYa = 0;
   for(i=0;i<=5-1;i++) SumYa += iMA(NULL,0,1,0,1,Price,i+shift);
   double Sum2a = SumBarsa * SumYa;
   double Num1a = 5 * Sum1a - Sum2a;
   double Num2a = SumBarsa * SumBarsa - 5 * SumSqrBarsa;
   if( Num2a != 0 ) 
	RegSlopea[shift] = 100*Num1a/Num2a;
   else 
	RegSlopea[shift] = 0; 
   }
   
   
      if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-10-1; 
   if ( counted_bars < 1 ) 
      for(i=1;i<10;i++) RegSlopeb[Bars-i]=0;    
   double SumBarsb = 10 * (10 - 1) * 0.5;
   double SumSqrBarsb = (10 - 1.0) * 10 * (2.0 * 10 - 1.0) / 6.0;
   for(shift=limit;shift>=0;shift--) 
   {	
   double Sum1b = 0;
   for(i=0;i<=10-1;i++) Sum1b += i*iMA(NULL,0,1,0,1,Price,i+shift);
   double SumYb = 0;
   for(i=0;i<=10-1;i++) SumYb += iMA(NULL,0,1,0,1,Price,i+shift);
   double Sum2b = SumBarsb * SumYb;
   double Num1b = 10 * Sum1b - Sum2b;
   double Num2b = SumBarsb * SumBarsb - 10 * SumSqrBarsb;
   if( Num2b != 0 ) 
	RegSlopeb[shift] = 100*Num1b/Num2b;
   else 
	RegSlopeb[shift] = 0; 
   }
   
      if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-15-1; 
   if ( counted_bars < 1 ) 
      for(i=1;i<15;i++) RegSlopec[Bars-i]=0;    
   double SumBarsc = 15 * (15 - 1) * 0.5;
   double SumSqrBarsc = (15 - 1.0) * 15 * (2.0 * 15 - 1.0) / 6.0;
   for(shift=limit;shift>=0;shift--) 
   {	
   double Sum1c = 0;
   for(i=0;i<=15-1;i++) Sum1c += i*iMA(NULL,0,1,0,1,Price,i+shift);
   double SumYc = 0;
   for(i=0;i<=15-1;i++) SumYc += iMA(NULL,0,1,0,1,Price,i+shift);
   double Sum2c = SumBarsc * SumYc;
   double Num1c = 15 * Sum1c - Sum2c;
   double Num2c = SumBarsc * SumBarsc - 15 * SumSqrBarsc;
   if( Num2c != 0 ) 
	RegSlopec[shift] = 100*Num1c/Num2c;
   else 
	RegSlopec[shift] = 0; 
   }
   Z =( RegSlopea[shift]+RegSlopeb[shift]+RegSlopec[shift]/3 );
    Comment(Z);
   RegSlope[0] =Z;

//----
	return(0);	
}

